diff -Naur inkscape2/src/extension/internal/javafx-fxz.cpp inkscape/src/extension/internal/javafx-fxz.cpp
--- inkscape2/src/extension/internal/javafx-fxz.cpp	1970-01-01 01:00:00.000000000 +0100
+++ inkscape/src/extension/internal/javafx-fxz.cpp	2009-02-12 00:27:17.000000000 +0100
@@ -0,0 +1,1480 @@
+/*
+ * JavaFX 1.0 plugin for Inkscape as a free extension to JavaFX Production Suite
+ *
+ * The output is JavaFX 1.0 Content File (.fxz) and can be viewed by netbeans with
+ * FXD viewer plugin installed.
+ *  
+ *  For information on JavaFX Production Suite, see:
+ *      http://javafx.com/docs/gettingstarted/production_suite/
+ *
+ *  For information on the JavaFX file format, see:
+ *      https://openjfx.dev.java.net/
+ *      
+ * Based on the work of authors:
+ * 
+ *   Bob Jamison <ishmal@inkscape.org>
+ *   Silveira Neto <silveiraneto@gmail.com>
+ *   Jim Clarke <Jim.Clarke@sun.com>
+ *
+ * Copyright (C) 2008 Authors
+ *
+ * Updates:
+ *   15 Jan 2009  by Sergey Esenov <serguei.essenov@desy.de>
+ *      - Added support for JavaFX Production Suite (.fxz) 
+ *        based on external 'libzip' library: http://www.nih.at/libzip
+ *      - Added support for gradients, simple texts, images (external and embedded).
+ *        Images are saved in ZIP archive together with content file
+ *
+ *   01 Feb 2009 by Sergey Esenov <serguei.essenov@desy.de>
+ *      - Added support for 'cycleMethod' (spreadMethod in inkscape) in gradients
+ *      - Changed gradient description policy: gradients in relational coordinates and
+ *        usage "proportional: true" where it is possible
+ *
+ * Released under GNU GPL, read the file 'COPYING' for more information
+ */
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#ifndef PANGO_ENABLE_BACKEND
+#define PANGO_ENABLE_BACKEND
+#endif
+
+#ifndef PANGO_ENABLE_ENGINE
+#define PANGO_ENABLE_ENGINE
+#endif
+
+#include <inkscape.h>
+#include <inkscape-version.h>
+#include <interface.h>
+#include <sp-root.h>
+#include <sp-defs.h>
+#include <sp-path.h>
+#include <sp-rect.h>
+#include <sp-ellipse.h>
+#include <sp-linear-gradient.h>
+#include <sp-radial-gradient.h>
+#include <sp-item-transform.h>
+#include <sp-gaussian-blur.h>
+#include <sp-filter.h>
+#include <sp-image.h>
+#include <sp-text.h>
+#include <gradient-chemistry.h>
+#include <text-editing.h>
+#include <sp-clippath.h>
+#include <style.h>
+#include <display/curve.h>
+#include <display/canvas-bpath.h>
+#include <svg/svg.h>
+
+#include <pango/pangofc-font.h>
+
+#include <libnr/nr-macros.h>
+#include <libnrtype/font-instance.h>
+
+#include <extension/system.h>
+#include <2geom/pathvector.h>
+#include <2geom/rect.h>
+#include <2geom/bezier-curve.h>
+#include <2geom/hvlinesegment.h>
+#include <2geom/coord.h>
+#include "helper/geom.h"
+#include "helper/geom-curves.h"
+#include <io/sys.h>
+
+#include <string>
+#include <stdio.h>
+#include <stdarg.h>
+#include <zip.h>           // external libzip1 library: http://www.nih.at/libzip
+#include "javafx-fxz.h"
+
+#ifdef WIN32
+#include <glib.h>
+#include <windows.h>
+#endif
+
+namespace Inkscape
+{
+namespace Extension
+{
+namespace Internal
+{
+
+static int  ntabs = 0;
+static char indent[1024];
+static bool definitions = false;
+
+//###################################################################################
+// The following snippet was based on b64.c from http://base64.sourceforge.net/b64.c
+//###################################################################################
+static const char cd64[]="|$$$}rstuvwxyz{$$$$$$$>?@ABCDEFGHIJKLMNOPQRSTUVW$$$$$$XYZ[\\]^_`abcdefghijklmnopq";
+
+static void decodeblock( unsigned char in[4], unsigned char out[3] )
+{   
+    out[ 0 ] = (unsigned char ) (in[0] << 2 | in[1] >> 4);
+    out[ 1 ] = (unsigned char ) (in[1] << 4 | in[2] >> 2);
+    out[ 2 ] = (unsigned char ) (((in[2] << 6) & 0xc0) | in[3]);
+}
+
+static int base64decode( char const *infile, int intlen, char *outfile )
+{
+    bool done = false;
+    unsigned char in[4], out[3], v;
+    int i, len, size = 0, pos = 0;
+
+    while( !done ) {
+        for( len = 0, i = 0; i < 4 && !done; i++ ) {
+            v = 0;
+            while( !done && v == 0 ) {
+                v = (unsigned char) infile[pos++];
+                if (pos == intlen)
+                    done = true;
+                v = (unsigned char) ((v < 43 || v > 122) ? 0 : cd64[ v - 43 ]);
+                if( v ) {
+                    v = (unsigned char) ((v == '$') ? 0 : v - 61);
+                }
+            }
+            if( !done ) {
+                len++;
+                if( v ) {
+                    in[ i ] = (unsigned char) (v - 1);
+                }
+            }
+            else {
+                in[i] = 0;
+            }
+        }
+        if( len ) {
+            decodeblock( in, out );
+            for( i = 0; i < len - 1; i++ ) {
+                outfile[size++] = out[i];
+            }
+        }
+    }
+    return size;
+}
+
+
+//########################################################################
+//# M E S S A G E S
+//########################################################################
+
+static void err(const char *fmt, ...)
+{
+    va_list args;
+    g_log(NULL,  G_LOG_LEVEL_WARNING, "javafx-fxz err: ");
+    va_start(args, fmt);
+    g_logv(NULL, G_LOG_LEVEL_WARNING, fmt, args);
+    va_end(args);
+    g_log(NULL,  G_LOG_LEVEL_WARNING, "\n");
+}
+
+
+//########################################################################
+//# U T I L I T Y
+//########################################################################
+
+/**
+ * Got this method from Bulia, and modified it a bit.  It basically
+ * starts with this style, gets its SPObject parent, walks up the object
+ * tree and finds all of the opacities and multiplies them.
+ *
+ * We use this for our "flat" object output.  If the code is modified
+ * to reflect a tree of <groups>, then this will be unneccessary.
+ */
+static double effective_opacity(const SPStyle *style)
+{
+    double val = 1.0;
+    for (SPObject const *obj = style->object; obj ; obj = obj->parent)
+    {
+        style = SP_OBJECT_STYLE(obj);
+        if (style)
+            val *= SP_SCALE24_TO_FLOAT(style->opacity.value);
+    }
+    return val;
+}
+
+/**
+ * Comment the file in zip archive
+ */
+static void zipfile_comment(ZipFile &zf, char const *filename, char const *comment)
+{
+    // put a comment for 'filename' 
+    struct zip_stat st;
+    zip_stat_init(&st);
+    zip_stat(zf, filename, 0, &st);   // index is st.index
+    zip_set_file_comment(zf, st.index, comment, strlen(comment));
+}
+
+/**
+ * Get the extension suffix from the end of a file name
+ */
+static Glib::ustring getExtension(const Glib::ustring &fname)
+{
+    Glib::ustring ext;
+
+    std::string::size_type pos = fname.rfind('.');
+    if (pos == fname.npos)
+        {
+        ext = "";
+        }
+    else
+        {
+        ext = fname.substr(pos);
+        }
+    return ext;
+}
+
+
+//########################################################################
+//# OUTPUT FORMATTING
+//########################################################################
+
+
+
+/**
+ * Format an rgba() string
+ */
+static JavaFXZ::String rgba(guint32 rgba)
+{
+    unsigned int r = SP_RGBA32_R_U(rgba);
+    unsigned int g = SP_RGBA32_G_U(rgba);
+    unsigned int b = SP_RGBA32_B_U(rgba);
+    unsigned int a = SP_RGBA32_A_U(rgba);
+    char buf[80];
+    snprintf(buf, 79, "Color.rgb(0x%02x, 0x%02x, 0x%02x, %.3f)", r, g, b, (double)a/256.0);
+    JavaFXZ::String s = buf;
+    return s;
+}
+
+
+/**
+ * Format an rgba() string for a color and a 0.0-1.0 alpha
+ */
+static JavaFXZ::String rgba(SPColor color, gdouble alpha)
+{
+    return rgba(color.toRGBA32(alpha));
+}
+
+
+/**
+ * Replace illegal characters for JavaFX for a underscore.
+ */
+static JavaFXZ::String sanatize(const JavaFXZ::String &badstr){
+    JavaFXZ::String good(badstr);
+    for (unsigned int pos = 0; pos < badstr.length(); ++pos )
+        if((badstr.at(pos)=='-')||(badstr.at(pos)==' '))
+            good.replace(pos, 1, "_");
+    return good;
+}
+
+
+/**
+ *  Output data to the buffer, printf()-style
+ */
+void JavaFXZ::out(const char *fmt, ...)
+{
+    va_list args;
+    va_start(args, fmt);
+    gchar *output = g_strdup_vprintf(fmt, args);
+    va_end(args);
+    outbuf.append(output);
+    g_free(output);
+}
+
+/**
+ * Output the file header
+ */
+bool JavaFXZ::doHeader(SPDocument *doc)
+{
+    time_t tim = time(NULL);
+    out("/*\n");
+    out(" * Generated by JavaFX plugin for Inkscape (http://www.inkscape.org)\n");
+    out(" * Created on %s",   ctime(&tim));
+    out(" * INKSCAPE Version: %s\n", Inkscape::version_string);
+    out(" * ###################################################################\n");
+    out(" * # NOTES:\n");
+    out(" * # ============\n");
+    out(" * # JavaFX information can be found at\n");
+    out(" * # https://openjfx.dev.java.net\n");
+    out(" * #\n");
+    out(" * # If you have any problems with this output, please see the\n");
+    out(" * # Inkscape project at http://www.inkscape.org, or visit\n");
+    out(" * # the #inkscape channel on irc.freenode.net . \n");
+    out(" * #\n");
+    out(" * ###################################################################\n");
+    out(" */\n//@version 1.0\n");
+
+    return true;
+}
+
+
+/**
+ *  Output the file footer
+ */
+bool JavaFXZ::doTail()
+{
+    //out("/* ###################################################################\n");
+    //out(" * # E N D   C L A S S    %s\n", name.c_str());
+    //out(" * ###################################################################\n");
+    //out(" */\n\n");
+    out("\n");
+    return true;
+}
+
+
+/**
+ *  Output gradient information to the buffer
+ */
+bool JavaFXZ::processGradient(SPGradient *grad)
+{
+    if (!grad)
+        return true;
+
+    Glib::ustring cycle = "";
+    SPGradientSpread spread = sp_gradient_get_spread(grad);
+    switch (spread) {
+        case SP_GRADIENT_SPREAD_REFLECT:
+            cycle = "cycleMethod: CycleMethod.REFLECT";
+            break;
+        case SP_GRADIENT_SPREAD_REPEAT:
+            cycle = "cycleMethod: CycleMethod.REPEAT";
+            break;
+        default:
+            break;
+    }
+
+    Geom::Matrix  gt   = grad->gradientTransform;
+    Geom::OptRect bbox = currentItem->getBounds(Geom::identity());
+
+    if (SP_IS_LINEARGRADIENT(grad))
+    {
+        double sX,sY,eX,eY;
+        SPLinearGradient *g = SP_LINEARGRADIENT(grad);
+        Geom::Point p1(g->x1.computed, g->y1.computed);
+        Geom::Point p2(g->x2.computed, g->y2.computed);
+        //--- position of gradient vector in user space (JavaFX -> proportional: false) 
+        Geom::Point p1t = p1 * gt ;
+        Geom::Point p2t = p2 * gt;
+        
+        out("%s        LinearGradient {\n", indent);
+/*        out("%s //No transform startX: %.5f, startY: %.5f, endX: %.5f, endY: %.5f\n",
+            indent,p1t[0],p1t[1],p2t[0],p2t[1]);*/
+        if (cycle.size() > 0)
+            out("%s            %s\n", indent, cycle.c_str());
+
+        if (0) // set 'if (bbox)' if LinerGradient bug is fixed
+        {
+            double w  = bbox->dimensions()[Geom::X];
+            double h  = bbox->dimensions()[Geom::Y];
+            double x0 = bbox->min()[Geom::X];
+            double y0 = bbox->min()[Geom::Y];
+            //out("%s //BBox x0: %.5f, y0: %.5f, w: %.5f, h: %.5f\n",indent,x0,y0,w,h);
+            Geom::Point q1(p1t[Geom::X] - x0, p1t[Geom::Y] - y0);
+            Geom::Point q2(p2t[Geom::X] - x0, p2t[Geom::Y] - y0);
+            sX = q1[Geom::X] / w;
+            sY = q1[Geom::Y] / h;
+            eX = q2[Geom::X] / w;
+            eY = q2[Geom::Y] / h;
+            out("%s            startX: %.8f, startY: %.8f, endX: %.8f, endY: %.8f\n",indent,sX,sY,eX,eY);
+            out("%s            proportional: true\n", indent);
+        } else {
+            sX = p1t[0];
+            sY = p1t[1];
+            eX = p2t[0];
+            eY = p2t[1];
+            out("%s            startX: %.5f, startY: %.5f, endX: %.5f, endY: %.5f\n",indent,sX,sY,eX,eY);
+            out("%s            proportional: false\n", indent);
+        }
+
+        std::vector<SPGradientStop> stops = g->vector.stops;
+        if (stops.size() > 0)
+        {
+            out("%s            stops: [\n", indent);
+            for (unsigned int i = 0 ; i<stops.size() ; i++)
+            {
+                SPGradientStop stop = stops[i];
+                out("%s                Stop { offset: %.3f, color: %s },\n",indent,stop.offset,rgba(stop.color, stop.opacity).c_str());
+            }
+            out("%s            ]\n", indent);
+        }
+        out("%s        }\n", indent);
+    }
+    else if (SP_IS_RADIALGRADIENT(grad))
+    {
+        SPRadialGradient *g = SP_RADIALGRADIENT(grad);
+        Geom::Matrix mc = Geom::Matrix(Geom::Translate(g->cx.value, g->cy.value)) * gt;
+        Geom::Matrix mf = Geom::Matrix(Geom::Translate(g->fx.value, g->fy.value)) * gt;
+        Geom::Matrix mr = Geom::Matrix(Geom::Scale(g->r.value, g->r.value)) * gt;
+        Geom::Point pc = mc.translation();
+        Geom::Point pf = mf.translation();
+        double centerX = pc[0];
+        double centerY = pc[1];
+        double focusX  = pf[0];
+        double focusY  = pf[1];
+        double radiusX = mr.expansionX();
+        double radiusY = mr.expansionY();
+
+        out("%s        RadialGradient {\n", indent);
+        if (cycle.size() > 0)
+            out("%s            %s\n", indent, cycle.c_str());
+        if (bbox)
+        {
+            Geom::Coord w = bbox->dimensions()[Geom::X];
+            Geom::Coord h = bbox->dimensions()[Geom::Y];
+            Geom::Point c = bbox->midpoint();          
+            out("%s            //BBox width: %.5f, height: %.5f, cX: %.5f, cY: %.5f\n",indent,w,h,c[0],c[1]);
+            double cX = (centerX - (c[0] - w/2)) / w;
+            double cY = (centerY - (c[1] - h/2)) / h;
+            double fX = (focusX  - (c[0] - w/2)) / w;
+            double fY = (focusY  - (c[1] - h/2)) / h;
+            double rX = radiusX / w;
+            double rY = radiusY / h;
+            out("%s            proportional: true\n", indent);
+            // use arithmetic mean value as temporary solution until "transforms:" will be implemented in RadialGradient 
+            out("%s            centerX: %.5f, centerY: %.5f, focusX: %.5f, focusY: %.5f, radius: %.5f //radiusX: %.5f, radiusY: %.5f\n",
+                indent,cX,cY,fX,fY,(rX+rY)/2.0,rX,rY);
+        }
+        else
+        {
+            //out("%s            //BBox NULL\n",indent);
+            if (SP_GRADIENT_UNITS(grad) == SP_GRADIENT_UNITS_USERSPACEONUSE)
+                out("%s            proportional: false\n", indent);
+            out("%s            centerX: %.5f, centerY: %.5f, focusX: %.5f, focusY: %.5f, radius: %.5f //radiusX: %.5f, radiusY: %.5f\n",
+                indent,centerX,centerY,focusX,focusY,(radiusX+radiusY)/2.0,radiusX,radiusY);
+        }
+
+        std::vector<SPGradientStop> stops = g->vector.stops;
+        if (stops.size() > 0)
+        {
+            out("%s            stops: [\n", indent);
+            for (unsigned int i = 0 ; i<stops.size() ; i++)
+            {
+                SPGradientStop stop = stops[i];
+                out("%s                Stop { offset: %.3f, color: %s },\n", indent, stop.offset, rgba(stop.color, stop.opacity).c_str());
+            }
+            out("%s            ]\n", indent);
+        }
+        out("%s        }\n", indent);
+    }
+    else
+    {
+        err("Unsupported gradient type\n");
+        return false;
+    }
+
+    return true;
+}
+
+/**
+ *  Output filter information to the buffer
+ */
+bool JavaFXZ::processFilter(SPFilter *filter)
+{
+    for (SPObject *child = filter->firstChild() ; child ; child = child->next)
+    {
+        if (!processEffect(child))
+            return false;
+    }
+    return true;
+}
+
+/**
+ *  Output clip-path information to the buffer
+ */
+bool JavaFXZ::processClipPath(SPClipPath *clip)
+{
+    for (SPObject *child = clip->firstChild(); child; child = child->next)
+    {
+        if ( !generateClip(child) )
+            return false;
+    }
+    return true;
+}
+
+/**
+ *  Output a clip attribute
+ */
+bool JavaFXZ::doClipPath(SPClipPathReference *ref)
+{
+    if (!ref)
+        return true;
+    if (ref->getObject() && ref->getURI()) {
+        Glib::ustring uri = ref->getURI()->toString();
+        if (uri.size() > 0 && uri[0]=='#')
+            uri = uri.substr(1);
+        SPClipPath *clip = clippaths[sanatize(uri)];
+        if (clip) {
+            if (!processClipPath(clip))
+                return false;
+        }
+    }
+    return true;
+}
+ 
+/**
+ *  Output an element's style attribute
+ */
+bool JavaFXZ::doStyle(SPStyle *style)
+{
+    if (!style)
+        return true;
+
+    out("%s    opacity: %.3f\n", indent, effective_opacity(style));
+
+    /**
+     * Fill
+     */
+    SPIPaint fill = style->fill;
+    if (fill.isColor())
+    {
+        // see color.h for how to parse SPColor
+        out("%s    fill: %s\n", indent, rgba(fill.value.color, SP_SCALE24_TO_FLOAT(style->fill_opacity.value)).c_str());
+    }
+    else if (fill.isPaintserver()) {
+        if (fill.value.href && fill.value.href->getURI() ) {
+            Glib::ustring uri = fill.value.href->getURI()->toString();
+            /* trim the anchor '#' from the front */
+            if (uri.size() > 0 && uri[0]=='#')
+                uri = uri.substr(1);
+            SPGradient *grad = gradients[sanatize(uri)];
+            if (!grad)
+                out("%s    fill: null\n", indent);
+            else {
+                out("%s    fill:\n", indent);
+                if (!processGradient(grad))
+                    return false;
+            }
+        }
+    }
+    else if (fill.isNoneSet())
+        out("%s    fill: null\n", indent);
+
+    /**
+     * Filter
+     */
+    SPIFilter filter = style->filter;
+    if (filter.set) {
+        if (filter.href && filter.href->getURI()) {
+            String uri = filter.href->getURI()->toString();
+            if (uri.size() > 0 && uri[0]=='#')
+                uri = uri.substr(1);
+            SPFilter *filter = effects[sanatize(uri)];
+            if (!processFilter(filter))
+                return false;
+        }
+    }
+
+    /**
+     * Stroke
+     */
+    /**
+     *NOTE:  Things in style we can use following limitations of JavaFX Data format:
+     * SPIPaint stroke;
+     * SPILength stroke_width;
+     * SPIFloat stroke_miterlimit;
+     * SPIScale24 stroke_opacity;
+     */
+    if (!style->stroke.isNone() && style->stroke_opacity.value > 0)
+    {
+        SPIPaint stroke = style->stroke;
+        out("%s    stroke: %s\n", indent, rgba(stroke.value.color, SP_SCALE24_TO_FLOAT(style->stroke_opacity.value)).c_str());
+        double strokewidth = style->stroke_width.computed;
+        out("%s    strokeWidth     : %.3f\n", indent, strokewidth);
+        out("%s    strokeMiterLimit: %.3f\n", indent, style->stroke_miterlimit.value);
+    }
+    else if (style->stroke.isNone())
+        out("%s    stroke: null\n", indent);
+
+    return true;
+}
+
+
+/**
+ *  Output rectangle to buffer
+ */
+bool JavaFXZ::doRect(SPRect *item, const Glib::ustring &jfxid)
+{
+    out("%sRectangle {\n", indent);
+    if (jfxid.substr(0,4) == "jfx:")
+        out("%s    id: \"%s\"\n", indent, jfxid.substr(4).c_str());
+    
+    if ( !doStyle(SP_OBJECT_STYLE(item)) )
+        return false;
+
+    out("%s    x: %.3f, y: %.3f, height: %.3f, width: %.3f, arcHeight: %.3f, arcWidth: %.3f\n",
+        indent, item->x.computed, item->y.computed, item->height.computed, item->width.computed,
+        2.0 * item->ry.computed, 2.0 * item->rx.computed);
+
+    if (item->clip_ref) {
+        if ( !doClipPath(item->clip_ref) )
+            return false;
+    }
+
+    Geom::Matrix const tm(sp_item_i2doc_affine(item));
+    if (!tm.isIdentity()) {
+        out("%s    transforms: [",indent);
+        if (tm.isTranslation())
+            out("Transform.translate(%.3f,%.3f)",tm[4],tm[5]);
+        else
+            out("Transform.affine(%.3f,%.3f,%.3f,%.3f,%.3f,%.3f)",tm[0],tm[1],tm[2],tm[3],tm[4],tm[5]);
+        out("]\n");
+    }
+
+    if (strlen(indent) > 0)
+        out("%s},\n",indent);
+    else
+        out("}\n");
+    return true;
+}
+
+
+/**
+ *  Output circle to buffer
+ */
+bool JavaFXZ::doCircle(SPGenericEllipse *item, const Glib::ustring &jfxid)
+{
+    out("%sCircle {\n", indent);
+    if (jfxid.substr(0,4) == "jfx:")
+        out("%s    id: \"%s\"\n", indent, jfxid.substr(4).c_str());
+
+    if ( !doStyle(SP_OBJECT_STYLE(item)) )
+        return false;
+
+    out("%s    centerX: %.3f, centerY: %.3f, radius: %.3f\n",
+        indent, item->cx.computed, item->cy.computed, item->rx.computed);
+
+    if (item->clip_ref) {
+        if ( !doClipPath(item->clip_ref) )
+            return false;
+    }
+
+    Geom::Matrix const tm(sp_item_i2doc_affine(item)); // <- _c[0],_c[1],_c[2],_c[3],_c[4],_c[5]
+    if (!tm.isIdentity()) {
+        out("%s    transforms: [",indent);
+        if (tm.isTranslation())
+            out("Transform.translate(%.3f,%.3f)",tm[4],tm[5]);
+        else
+            out("Transform.affine(%.3f,%.3f,%.3f,%.3f,%.3f,%.3f)",tm[0],tm[1],tm[2],tm[3],tm[4],tm[5]);
+        out("]\n");
+    }
+
+    if (strlen(indent) > 0)
+        out("%s},\n",indent);
+    else
+        out("}\n");
+    return true;
+}
+
+
+/**
+ *  Output ellipse to buffer
+ */
+bool JavaFXZ::doEllipse(SPGenericEllipse *item, const Glib::ustring &jfxid)
+{
+    out("%sEllipse {\n", indent);
+    if (jfxid.substr(0,4) == "jfx:")
+        out("%s    id: \"%s\"\n", indent, jfxid.substr(4).c_str());
+
+    if ( !doStyle(SP_OBJECT_STYLE(item)) )
+        return false;
+
+    out("%s    centerX: %.3f, centerY: %.3f, radiusX: %.3f, radiusY: %.3f\n",
+        indent, item->cx.computed, item->cy.computed, item->rx.computed, item->ry.computed);
+
+    if (item->clip_ref) {
+        if ( !doClipPath(item->clip_ref) )
+            return false;
+    }
+
+    Geom::Matrix const tm(sp_item_i2doc_affine(item));
+    if (!tm.isIdentity()) {
+        out("%s    transforms: [",indent);
+        if (tm.isTranslation())
+            out("Transform.translate(%.3f,%.3f)",tm[4],tm[5]);
+        else
+            out("Transform.affine(%.3f,%.3f,%.3f,%.3f,%.3f,%.3f)",tm[0],tm[1],tm[2],tm[3],tm[4],tm[5]);
+        out("]\n");
+    }
+
+    if (strlen(indent) > 0)
+        out("%s},\n",indent);
+    else
+        out("}\n");
+    return true;
+}
+
+
+/**
+ *  Output the curve data to buffer
+ */
+bool JavaFXZ::doCurve(SPItem *item, const Glib::ustring &jfxid)
+{
+    using Geom::X;
+    using Geom::Y;
+
+    SPShape *shape = SP_SHAPE(item);
+    SPCurve *curve = shape->curve;
+    if (curve->is_empty())
+        return true;
+
+    out("%sSVGPath {\n", indent);
+    if (jfxid.substr(0,4) == "jfx:")
+        out("%s    id: \"%s\"\n", indent, jfxid.substr(4).c_str());
+
+    gchar const *d = sp_object_getAttribute(item, "d", NULL);
+    out("%s    content: \"%s\"\n", indent, d);
+    out("%s    fillRule: FillRule.NON_ZERO\n", indent);
+
+    if ( !doStyle(SP_OBJECT_STYLE(item)) )
+        return false;
+
+    if (item->clip_ref) {
+        if ( !doClipPath(item->clip_ref) )
+            return false;
+    }
+
+    Geom::Matrix const tm(sp_item_i2doc_affine(item));
+    if (!tm.isIdentity()) {
+        out("%s    transforms: [",indent);
+        if (tm.isTranslation())
+            out("Transform.translate(%.3f,%.3f)",tm[4],tm[5]);
+        else
+            out("Transform.affine(%.3f,%.3f,%.3f,%.3f,%.3f,%.3f)",tm[0],tm[1],tm[2],tm[3],tm[4],tm[5]);
+        out("]\n");
+    }
+
+    if (strlen(indent) > 0)
+        out("%s},\n",indent);
+    else
+        out("}\n");
+    return true;
+}
+
+
+bool JavaFXZ::doImage(ZipFile &zf, SPImage *image, const Glib::ustring &jfxid)
+{
+    out("%sImageView {\n", indent);
+    if (jfxid.substr(0,4) == "jfx:")
+        out("%s    id: \"%s\"\n", indent, jfxid.substr(4).c_str());
+    out("%s    x: %s, y: %s, width: %s, height: %s\n", indent,
+                sp_object_getAttribute(image, "x", NULL),
+                sp_object_getAttribute(image, "y", NULL),
+                sp_object_getAttribute(image, "width",  NULL),
+                sp_object_getAttribute(image, "height", NULL));
+
+    char const   *data_string = "data:image/";
+    char const   *refstr = sp_object_getAttribute(image, "xlink:href", NULL);
+    Glib::ustring href   = refstr;
+   
+    if (data_string == href.substr(0,strlen(data_string)))
+    {
+        std::string::size_type pos = href.find("/") + 1;
+        Glib::ustring       suffix = href.substr(pos, 3);
+
+        // Check that embedded image is base64 encoded one
+        pos = href.find(";");
+        if ( href.substr(pos+1, 6) == "base64" )
+        {
+            // Build canonical name for image in zip archive
+            char buf[256];
+            snprintf(buf, sizeof(buf), "Pictures/image%u.%s",
+                    static_cast<unsigned int>(imageTable.size()), suffix.c_str());
+            Glib::ustring newName = buf;
+            Glib::ustring oldName = newName.substr(newName.find("/") + 1);
+            imageTable[oldName] = newName;
+
+            // find position of encoded image and decode
+            pos = href.find(",") + 1;
+            int  encoded_size = strlen(refstr + pos); 
+            char *decoded_image = new char[encoded_size]; // allocate the same size 
+            int image_size = base64decode(refstr + pos, encoded_size, decoded_image);
+
+            ZipEntry *ze = zip_source_buffer(zf, decoded_image, image_size, 0);
+            if (ze) {
+                zip_add(zf, newName.c_str(), ze);
+                zipfile_comment(zf, newName.c_str(), "Extracted embedded image");
+            }
+            // to garantee our changes being saved into archive ...
+            zip_close(zf);
+            delete[] decoded_image;
+            Glib::ustring pathName = documentUri.getNativePath();
+            int err = 0;
+            zf = zip_open(pathName.c_str(), 0, &err);
+
+            out("%s    image: Image {url: \"{__DIR__}%s\"}\n",indent,imageTable[oldName].c_str());
+        }
+        else
+        {
+            char message[256];
+            sprintf(message,"Unsupported format of embedded image '%s' in JavaFX 1.0 ('null' image substituted)\n"
+                            "Hint: use \"Effects->Images->Extract One Image...\" first!", jfxid.c_str());
+            sp_ui_error_dialog(message);
+            out("%s    image: Image {url: null}\n", indent);
+        }
+    } 
+    else
+    {
+        Glib::ustring oldName = href;
+        Glib::ustring ext = getExtension(oldName);
+        if (ext == ".jpeg")
+            ext = ".jpg";
+        // if the (old) name not found, rename it
+        if (imageTable.find(oldName) == imageTable.end())
+        {
+            // Build canonical name for image in zip archive
+            char buf[256];
+            snprintf(buf, sizeof(buf), "Pictures/image%u%s",
+                    static_cast<unsigned int>(imageTable.size()), ext.c_str());
+            Glib::ustring newName = buf;
+            imageTable[oldName] = newName;
+            Glib::ustring comment = "old name was: ";
+            comment.append(oldName);
+            URI oldUri(oldName);
+            //g_message("oldpath:%s", oldUri.getNativePath().c_str());
+            //# if relative to the documentURI, get proper path
+            URI resUri = documentUri.resolve(oldUri);
+            Glib::ustring pathName = resUri.getNativePath();
+            //g_message("native path:%s", pathName.c_str());
+            ZipEntry *ze = zip_source_file(zf, pathName.c_str(), 0, -1);
+            if (ze) {
+                zip_add(zf, newName.c_str(), ze);
+                zipfile_comment(zf, newName.c_str(), comment.c_str());
+            }                
+        }              
+        out("%s    image: Image {url: \"{__DIR__}%s\"}\n", indent, imageTable[oldName].c_str());
+    }
+
+    if (image->clip_ref) {
+        if ( !doClipPath(image->clip_ref) )
+            return false;
+    }
+
+    Geom::Matrix const tm(sp_item_i2doc_affine(image));
+    if (!tm.isIdentity()) {
+        out("%s    transforms: [",indent);
+        if (tm.isTranslation())
+            out("Transform.translate(%.3f,%.3f)",tm[4],tm[5]);
+        else
+            out("Transform.affine(%.3f,%.3f,%.3f,%.3f,%.3f,%.3f)",tm[0],tm[1],tm[2],tm[3],tm[4],tm[5]);
+        out("]\n");
+    }
+
+    if (strlen(indent) > 0)
+        out("%s},\n",indent);
+    else
+        out("}\n");
+    return true;
+}
+
+
+bool JavaFXZ::doText(ZipFile &zf, SPText *text, const Glib::ustring &jfxid)
+{
+    out("%sText {\n", indent);
+    if (jfxid.substr(0,4) == "jfx:")
+        out("%s    id: \"%s\"\n", indent, jfxid.substr(4).c_str());
+
+    //------------------------------------------------- get common style info
+    SPStyle  *style = SP_OBJECT_STYLE(text);
+    if ( !doStyle(style) )
+        return false;
+   //------------------------------------------- get Text specific style info
+    if (style->text_decoration.set) {
+        if (style->text_decoration.overline)
+            out("%s    overline: true\n", indent);
+        if (style->text_decoration.underline)
+            out("%s    underline: true\n", indent);
+        if (style->text_decoration.line_through)
+            out("%s    strikethrough: true\n", indent);
+    }
+    if (style->text_align.set) {
+        if (style->text_align.value == SP_CSS_TEXT_ALIGN_LEFT ||
+                    style->text_align.value == SP_CSS_TEXT_ALIGN_START) 
+            out("%s    textAlignment: TextAlignment.LEFT\n", indent);
+        else if (style->text_align.value == SP_CSS_TEXT_ALIGN_RIGHT ||
+                    style->text_align.value == SP_CSS_TEXT_ALIGN_END)
+            out("%s    textAlignment: TextAlignment.RIGHT\n", indent);
+        else if (style->text_align.value == SP_CSS_TEXT_ALIGN_CENTER)
+            out("%s    textAlignment: TextAlignment.CENTER\n", indent);
+        else if (style->text_align.value == SP_CSS_TEXT_ALIGN_JUSTIFY)
+            out("%s    textAlignment: TextAlignment.JUSTIFY\n", indent); 
+    }
+
+    //****************************** EXPERIMENTAL ********************
+    Glib::ustring fontfile = "";
+    font_instance * font = font_factory::Default()->FaceFromStyle(style);
+    if (font) {
+        if (fontfile == "") {
+            FcChar8 *fname = NULL;
+            PangoFont *pf = font->pFont;
+            if (PANGO_IS_FC_FONT(pf)) {
+                PangoFcFont *pfc = PANGO_FC_FONT(pf);
+                if (pfc)
+                    FcPatternGetString(pfc->font_pattern, FC_FILE, 0, &fname);
+                if (fname)
+                    fontfile.append(reinterpret_cast<char*>(fname));
+            }
+        }
+#ifdef WIN32
+        if (fontfile == "") {
+            // The filename related to above font_instance maybe retrieved from the
+            // value "HKEY_LOCAL_MACHINE\Software\Microsoft\Windows NT\CurrentVersion\Fonts"
+            HKEY key = NULL;
+            Glib::ustring spec = "";
+            WCHAR *lpValueName = NULL;
+            if (style->text->font_specification.set) {
+                spec.append(style->text->font_specification.value);
+                spec.append(" (TrueType)");     // add (TrueType), (VGA res), (all res), ... 
+                lpValueName = (WCHAR*)g_utf8_to_utf16(spec.c_str(), -1, NULL, NULL, NULL);
+            }
+            if (lpValueName && RegOpenKeyExA(HKEY_LOCAL_MACHINE,
+                "Software\\Microsoft\\Windows NT\\CurrentVersion\\Fonts",
+                0, KEY_QUERY_VALUE, &key) == ERROR_SUCCESS)
+            {
+                WCHAR utf16filename[_MAX_PATH];
+                DWORD value_type;
+                DWORD data_size = sizeof(utf16filename);
+                if (RegQueryValueExW(key, lpValueName, NULL, &value_type,
+                        (BYTE*)utf16filename, &data_size) == ERROR_SUCCESS)
+                {
+                    g_assert(value_type == REG_SZ);
+                    gchar *utf8filename = g_utf16_to_utf8((const gunichar2*)utf16filename,
+                                                            -1, NULL, NULL, NULL);
+                    if (utf8filename)
+                    {
+                        fontfile = "C:\\WINDOWS\\Fonts\\";
+                        if (utf8filename[1] == ':')
+                            fontfile = Glib::ustring(utf8filename);
+                        else
+                            fontfile.append(Glib::ustring(utf8filename));
+                        g_free(utf8filename);
+                    }
+                }
+                RegCloseKey(key);
+            }
+        }
+#endif
+        font->Unref();
+        font = NULL;
+    }
+    //****************************** END OF EXP   ********************
+
+    //--------------------------------------------- set Font.font(....)
+    char fontstr[256];
+    if ( fontfile.size() == 0 || !style->text->font_family.set    ||
+         strcmp(style->text->font_family.value, "Arial") == 0     ||
+         strcmp(style->text->font_family.value, "Sans Serif") == 0 ||
+         strcmp(style->text->font_family.value, "Times New Roman") == 0 )
+    {
+        snprintf(fontstr, 256, "%s    font: Font.font(", indent);
+        if (style->text->font_family.set)
+            snprintf(fontstr+strlen(fontstr), 256,"\"%s\", ", style->text->font_family.value);
+        else
+            snprintf(fontstr+strlen(fontstr), 256,"null, ");
+
+        if (style->font_weight.set && style->font_weight.value >= SP_CSS_FONT_WEIGHT_BOLD)
+            snprintf(fontstr+strlen(fontstr), 256, "FontWeight.BOLD, ");
+        else
+            snprintf(fontstr+strlen(fontstr), 256, "FontWeight.REGULAR, ");
+
+        if (style->font_style.set && style->font_style.value == SP_CSS_FONT_STYLE_ITALIC)
+            snprintf(fontstr+strlen(fontstr), 256, "FontPosture.ITALIC, ");
+        else
+            snprintf(fontstr+strlen(fontstr), 256, "FontPosture.REGULAR, ");
+
+        if (style->font_size.set) {
+            snprintf(fontstr+strlen(fontstr), 256, "%.3f)", style->font_size.computed);
+            out("%s\n", fontstr);
+        }
+    } else {
+        bool found = false;
+        //---------------------------- check if we have already this fontfile
+        std::vector<Glib::ustring>::const_iterator it;
+        for (it = fontVector.begin(); it != fontVector.end(); ++it) {
+            if (*it == fontfile) {
+                found = true;
+            }
+        }
+        Glib::ustring newName = "Fonts/";
+        newName.append(Glib::path_get_basename(fontfile));
+        if (!found) {
+            //------------------------- put fontfile into archive
+            URI font_uri(fontfile);
+            URI resUri = documentUri.resolve(font_uri);
+            Glib::ustring pathName = resUri.getNativePath();
+            g_message("%s //native path:%s, item name:%s", indent, pathName.c_str(), newName.c_str());
+            ZipEntry *ze = zip_source_file(zf, pathName.c_str(), 0, -1);
+            if (ze) {
+                zip_add(zf, newName.c_str(), ze);
+                zipfile_comment(zf, newName.c_str(), "Embedded font" );
+                //------------------------- put new fontfile into vector
+                fontVector.push_back(fontfile);
+                found = true;
+           }
+        }
+        if (style->font_size.set && found) {
+            out("%s    font: Font.fontFromURL(\"{__DIR__}%s\", %.3f)\n",
+                indent,newName.c_str(),style->font_size.computed);
+        }
+    }
+    //Inkscape::XML::Node *node = SP_OBJECT(text)->repr;
+    char const *posX = sp_object_getAttribute(text, "x", NULL);
+    char const *posY = sp_object_getAttribute(text, "y", NULL);
+    if (posX && posY)
+        out("%s    x: %s, y: %s\n", indent, posX, posY);
+    else {
+        if (posX)
+            out("%s    x: %s\n", indent, posX);
+        if (posY)
+            out("%s    y: %s\n", indent, posY);
+    }
+    Inkscape::Text::Layout const *layout = te_get_layout(text);
+    Glib::ustring content = sp_te_get_string_multiline(text, layout->begin(), layout->end());
+    out("%s    content: \"%s\"\n", indent, content.c_str());
+
+    if (text->clip_ref) {
+        if ( !doClipPath(text->clip_ref) )
+            return false;
+    }
+
+    // build transformation matrix:
+    Geom::Matrix const tm(sp_item_i2doc_affine(text)); // <- _c[0],_c[1],_c[2],_c[3],_c[4],_c[5]
+    if (!tm.isIdentity()) {
+        out("%s    transforms: [",indent);
+        if (tm.isTranslation())
+            out("Transform.translate(%.3f,%.3f)",tm[4],tm[5]);
+        else
+            out("Transform.affine(%.3f,%.3f,%.3f,%.3f,%.3f,%.3f)",tm[0],tm[1],tm[2],tm[3],tm[4],tm[5]);
+        out("]\n");
+    }
+
+    if (strlen(indent) > 0)
+        out("%s},\n",indent);
+    else
+        out("}\n");
+    return true;
+}
+
+
+/**
+ *  Output the tree data to buffer
+ */
+bool JavaFXZ::processEffect(SPObject *obj)
+{
+    if (SP_IS_GAUSSIANBLUR(obj)) {
+        SPGaussianBlur *blur = SP_GAUSSIANBLUR(obj);
+        double radius = 2.0 * blur->stdDeviation.getNumber();
+        if (radius >= 64.0)
+            radius = 64.0;
+        if (radius <= 1.0)
+            radius = 1.0;
+        out("%s    effect: GaussianBlur { radius : %.3f }\n", indent, radius);
+    }
+
+    for (SPObject *child = obj->firstChild() ; child ; child = child->next)
+    {
+		if (!processEffect(child))
+		    return false;
+    }
+
+    return true;
+}
+
+/**
+ *  Output the path data to buffer
+ */
+bool JavaFXZ::generateClip(SPObject *obj)
+{
+    bool ret = true;
+    gchar orig_indent[4096];
+    Glib::ustring id;
+    gchar const *cid = sp_object_getAttribute(obj, "id", NULL);
+    
+    if (!cid)
+        return true;
+
+    // Convert SVG id to "valid" JavaFX id
+    id  = sanatize(cid);
+
+    strcpy(orig_indent, indent);   // save original indent
+    sprintf(indent+strlen(indent), "        ");   //add two indentation shifts
+
+    SPItem *item = SP_ITEM(obj);
+
+    if (SP_IS_RECT(item)) {
+        out("%s    clip:\n",orig_indent);
+        SPRect *rect = SP_RECT(item);
+        if ( !doRect(rect, id) )
+            ret = false;
+        goto finish;
+    }
+    if (SP_IS_GENERICELLIPSE(item)) {
+        SPGenericEllipse *ellipse = SP_GENERICELLIPSE(item);
+        //------------------------------- if path is not closed
+        if ( !ellipse->closed )
+            goto svgpath;
+        if ( (ellipse->start + 3.14159265358979323846 - ellipse->end) > 1e-8 )
+            goto svgpath;
+        out("%s    clip:\n",orig_indent);
+        if ( (ellipse->rx.computed - ellipse->ry.computed) < 1e-8 ) {
+            if ( !doCircle(ellipse, id) )
+                ret = false;
+            goto finish;
+        }
+        if (!doEllipse(ellipse, id))
+            ret = false;
+        goto finish;
+    }
+
+svgpath:
+    out("%s    clip:\n",orig_indent);
+    if (!doCurve(item, id))
+        ret = false;
+
+finish:
+    strcpy(indent, orig_indent);
+    return true;
+}
+
+
+//########################################################################
+//# M A I N    O U T P U T
+//########################################################################
+
+
+
+/**
+ *  Set values back to initial state
+ */
+void JavaFXZ::reset()
+{
+    // In case of pointers, unreference first and then clear
+    std::map<Glib::ustring, SPGradientPtr>::iterator ig;
+    for (ig = gradients.begin(); ig != gradients.end(); ig++) {
+        ig->second = NULL;
+    }
+    gradients.clear();
+
+    std::map<Glib::ustring, SPFilterPtr>::iterator ie;
+    for (ie = effects.begin(); ie != effects.end(); ie++) {
+        ie->second = NULL;
+    }
+    effects.clear();
+
+    std::map<Glib::ustring, SPClipPathPtr>::iterator ic;
+    for (ic = clippaths.begin(); ic != clippaths.end(); ic++) {
+        ic->second = NULL;  // unref
+    }
+    clippaths.clear();
+
+    imageTable.clear();
+    fontVector.clear();
+    name.clear();
+    outbuf.clear();
+}
+
+
+/**
+ *  Output the tree data to buffer
+ */
+bool JavaFXZ::traverseTree(ZipFile &zf, Inkscape::XML::Node *node)
+{
+    /**
+     * Check the type of node and process
+     */
+    int i;
+    Glib::ustring id;
+    SPObject *obj = NULL;
+    Glib::ustring nodeName = node->name();
+    char const *cid = node->attribute("id");
+    bool rc = true;
+
+    indent[0] = '\0';
+    for (i = 0; i<ntabs; i++)
+        strcat(indent,"    ");
+
+    if (!cid)
+        goto recursion;
+
+    // Convert SVG id to "valid" JavaFX id
+    id  = sanatize(cid);
+
+    // Get object by node
+    obj = SP_ACTIVE_DOCUMENT->getObjectByRepr(node);
+    if (!obj)
+        goto recursion;
+
+    do {
+        if (SP_IS_GROUP(obj)) {
+            //out("%s//    OBJECT id: %s is GROUP\n", indent, cid);
+            out("%sGroup {\n", indent);
+            if (strncmp(obj->id, "jfx:", 4) == 0)
+                out("%s    id: \"%s\"\n", indent, obj->id + 4);
+            ntabs++;
+            strcat(indent,"    ");
+            out("%scontent: [\n", indent);
+            break; 
+        }
+        if (SP_IS_IMAGE(obj)) {
+            //out("%s//    OBJECT id: %s is IMAGE\n", indent, cid);
+            SPImage *image = SP_IMAGE(obj);
+            if (!doImage(zf, image, id)) {
+                rc = false;
+                goto finish;
+            }
+            break;
+        }
+        if (SP_IS_TEXT(obj)) {
+            //out("%s//    OBJECT id: %s is TEXT\n", indent, cid);
+            SPText *text = SP_TEXT(obj);
+            if (!doText(zf, text, id)) {
+                rc = false;
+                goto finish;
+            }
+            break;
+        }
+        if (SP_IS_GRADIENT(obj)) {
+            //out("%s//    OBJECT id: %s is GRADIENT\n", indent, cid);
+            SPGradient *grad = SP_GRADIENT(obj);
+            gradients[id] = grad;
+            break;
+        }
+        if (SP_IS_FILTER(obj)) {
+            //out("%s//    OBJECT id: %s is FILTER\n", indent, cid);
+            SPFilter *filter = SP_FILTER(obj);
+            effects[id] = filter;
+            break;
+        }
+        if (SP_IS_CLIPPATH(obj)) {
+            //out("%s//    OBJECT id: %s is CLIPPATH\n", indent, cid);
+            SPClipPath *clip = SP_CLIPPATH(obj);
+            clippaths[id] = clip;
+            break;
+        }       
+        if (SP_IS_SHAPE(obj)) {
+            if (definitions)
+                break;          // ignore in case of '<defs>'  
+            //out("%s//    OBJECT id: %s is SHAPE\n", indent, cid);
+            //SPShape *shape = SP_SHAPE(obj);
+            currentItem = SP_ITEM(obj);
+            if (SP_IS_RECT(obj)) {
+                //out("%s//    OBJECT id: %s is RECTANGLE\n", indent, cid);
+                SPRect *item = SP_RECT(obj);
+                if (!doRect(item, id)) {
+                    rc = false;
+                    goto finish;
+                }
+                break;
+            }
+            else if (SP_IS_GENERICELLIPSE(obj)) {
+                //out("%s//    OBJECT id: %s is GENERICELLIPSE\n", indent, cid);
+                SPGenericEllipse *ellipse = SP_GENERICELLIPSE(obj);
+                if ( !ellipse->closed )
+                    goto svgpath;
+                if ( (ellipse->start + 3.14159265358979323846 - ellipse->end) > 1e-8 )
+                    goto svgpath;
+                if ( (ellipse->rx.computed - ellipse->ry.computed) < 1e-8 ) {
+                    if (!doCircle(ellipse, id)) {
+                        rc = false;
+                        goto finish;
+                    }
+                    break;
+                }
+                if (!doEllipse(ellipse, id)) {
+                    rc = false;
+                    goto finish;
+                }
+                break;
+            }
+
+   svgpath:
+            if (definitions)
+                break;
+            //out("%s//    OBJECT id: %s is ITEM\n", indent, cid);
+            SPItem *item = SP_ITEM(obj);
+            currentItem = item;
+            if (!doCurve(item, id)) {
+                rc = false;
+                goto finish;
+            }
+            break;     
+        }
+        
+        /*
+        if (SP_IS_ITEM(obj)) {
+            out("%s//    OBJECT id: %s is ITEM and NOT a SHAPE\n", indent, cid);
+            break;
+        }
+        else
+            out("%s//    OBJECT id: %s is NOT ITEM\n", indent, cid);
+        */
+    } while(0);
+
+
+recursion:
+    if (SP_IS_DEFS(obj))
+        definitions = true;
+    else
+        ntabs++;    
+
+    for (Inkscape::XML::Node *child = node->firstChild(); child; child = child->next())
+    {
+        if (!traverseTree(zf, child)) {
+            rc = false;
+            break;
+        }
+    }
+
+    if (SP_IS_DEFS(obj))
+        definitions = false;
+    else
+        ntabs--;
+    indent[4 * ntabs] = '\0';
+    
+
+    if (SP_IS_GROUP(obj))
+    {
+        out("%s]\n", indent);
+        ntabs--;
+        indent[4 * ntabs] = '\0';
+    }
+
+    if (  SP_IS_GROUP(obj) )
+    {
+        if (ntabs)
+            out("%s},\n", indent);
+        else
+            out("}\n");
+    }
+
+finish:
+    return rc;
+}
+
+
+/**
+ * Saves the <paths> of an Inkscape SVG file as JavaFX spline definitions
+ */
+bool JavaFXZ::saveDocument(SPDocument *doc, gchar const *uri)
+{
+    reset();
+
+    Glib::ustring dirname = Glib::path_get_dirname(uri);
+    name = Glib::path_get_basename(uri);
+
+    int pos = name.find('.');
+    if (pos > 0)
+        name = name.substr(0, pos);
+
+    //g_message("native file:%s, name %s, dirname %s\n", uri, name.c_str(), dirname.c_str());
+    unlink(uri);
+    documentUri = URI(uri);
+    ZipFile zf;
+    int err = 0;
+    zf = zip_open(uri, ZIP_CREATE | ZIP_EXCL, &err);
+    // TODO:  Here we need to handle error code
+
+    ntabs = 0;
+    definitions = false;
+    if (!traverseTree(zf, doc->rroot))
+        return false;
+
+    String curveBuf = outbuf;
+    outbuf.clear();
+
+    if (!doHeader(doc))
+        return false;
+
+    outbuf.append(curveBuf);
+
+    if (!doTail())
+        return false;
+
+    ZipEntry *ze = zip_source_buffer(zf, outbuf.c_str(), outbuf.size(), 0);
+    if (ze) {
+        zip_add(zf, "content.fxd", ze);
+        zipfile_comment(zf,"content.fxd","JavaFX Data file");
+    }
+    zip_close(zf);
+
+    return true;
+}
+
+
+//########################################################################
+//# EXTENSION API
+//########################################################################
+
+#include "clear-n_.h"
+
+/**
+ * API call to save document
+*/
+void
+JavaFXZ::save(Inkscape::Extension::Output */*mod*/,
+                        SPDocument *doc, gchar const *uri)
+{
+    if (!saveDocument(doc, uri))
+    {
+        g_warning("Could not save JavaFX file '%s'", uri);
+    }
+}
+
+
+
+/**
+ * Make sure that we are in the database
+ */
+bool JavaFXZ::check (Inkscape::Extension::Extension */*module*/)
+{
+    /* We don't need a Key
+    if (NULL == Inkscape::Extension::db.get(SP_MODULE_KEY_OUTPUT_JFX))
+        return FALSE;
+    */
+
+    return true;
+}
+
+
+
+/**
+ * This is the definition of JavaFX output.  This function just
+ * calls the extension system with the memory allocated XML that
+ * describes the data.
+*/
+void
+JavaFXZ::init()
+{
+    Inkscape::Extension::build_from_mem(
+        "<inkscape-extension xmlns=\"" INKSCAPE_EXTENSION_URI "\">\n"
+            "<name>" N_("FXD/FXZ Output") "</name>\n"
+            "<id>org.inkscape.output.fxd</id>\n"
+            "<output>\n"
+                "<extension>.fxz</extension>\n"
+                "<mimetype>text/x-javafx-content</mimetype>\n"
+                "<filetypename>" N_("JavaFX Content (*.fxz)") "</filetypename>\n"
+                "<filetypetooltip>" N_("JavaFX FXD/FXZ Content File") "</filetypetooltip>\n"
+            "</output>\n"
+        "</inkscape-extension>",
+        new JavaFXZ());
+}
+
+
+
+
+}  // namespace Internal
+}  // namespace Extension
+}  // namespace Inkscape
+
+
+/*
+  Local Variables:
+  mode:c++
+  c-file-style:"stroustrup"
+  c-file-offsets:((innamespace . 0)(inline-open . 0)(case-label . +))
+  indent-tabs-mode:nil
+  fill-column:99
+  End:
+*/
+// vim: filetype=cpp:expandtab:shiftwidth=4:tabstop=8:softtabstop=4:encoding=utf-8:textwidth=99 :
